@ECHO off
REM
REM THIS PRODUCT CONTAINS RESTRICTED MATERIALS OF IBM
REM
REM  5724-I63, 5724-H88, 5655-N02, 5733-W70 (C) COPYRIGHT International Business Machines Corp. 2005, 2011
REM
REM  The source code for this program is not published or otherwise divested
REM  of its trade secrets, irrespective of what has been deposited with the
REM  U.S. Copyright Office.
REM
REM ----------------------------------------------------------------------------

SETLOCAL

PUSHD %~dp0..\..\..\..\bin
CALL "setupCmdLine.bat" %*
POPD

SET RC=0
SET FILE=
SET HOST=\"\"
SET PORT=\"\"
SET USERNAME=\"\"
SET PASSWORD=\"\"
SET NODENAME=
SET SERVERNAME=

IF [%1]=="" SET RC=1 & GOTO PRINT_USAGE

:PARAM_LOOP
IF [%1]==[] GOTO VERIFY_INPUTS

IF [%1]==[-help] GOTO PRINT_USAGE
IF [%1]==[-?] GOTO PRINT_USAGE

IF [%1]==[-host] SET HOST=%2 & SHIFT & SHIFT & GOTO PARAM_LOOP
IF [%1]==[-h] SET HOST=%2 & SHIFT & SHIFT & GOTO PARAM_LOOP

IF [%1]==[-port] SET PORT=%2 & SHIFT & SHIFT & GOTO PARAM_LOOP
IF [%1]==[-t] SET PORT=%2 & SHIFT & SHIFT & GOTO PARAM_LOOP

IF [%1]==[-username] SET USERNAME=%2 & SHIFT & SHIFT & GOTO PARAM_LOOP
IF [%1]==[-u] SET USERNAME=%2 & SHIFT & SHIFT & GOTO PARAM_LOOP

IF [%1]==[-password] SET PASSWORD=%2 & SHIFT & SHIFT & GOTO PARAM_LOOP
IF [%1]==[-p] SET PASSWORD=%2 & SHIFT & SHIFT & GOTO PARAM_LOOP

IF [%1]==[-profileName] SET PROFILENAME=%2 & SHIFT & SHIFT & GOTO PARAM_LOOP

IF [%1]==[-serverName] SET SERVERNAME=%2 & SHIFT & SHIFT & GOTO PARAM_LOOP

IF [%1]==[-nodeName] SET NODENAME=%2 & SHIFT & SHIFT & GOTO PARAM_LOOP


:VERIFY_INPUTS
IF [%1]==[] SET RC=1 & ECHO Package name is missing. & GOTO PRINT_USAGE
IF [%2]==[] SET RC=1 & ECHO Installation state is missing. & GOTO PRINT_USAGE

SET FILE="%~f1"

IF "%NODENAME%"=="" GOTO CHECKSERVER_EMPTY
IF "%SERVERNAME%"=="" GOTO PRINT_USAGE
REM Getting here means, it's SERVER_ND, Check HOST and PORT
ECHO Target Server Type is ND Configuration, Host and Port required.
IF "%HOST%"=="" GOTO PRINT_USAGE
IF "%PORT%"=="" GOTO PRINT_USAGE
IF %HOST%==\"\" GOTO PRINT_USAGE
IF %PORT%==\"\" GOTO PRINT_USAGE

GOTO SERVER_ND
SET RC=1 & GOTO PRINT_USAGE

REM Check for both server and node names as empty as this is for a stand-alone profile
:CHECKSERVER_EMPTY
IF "%SERVERNAME%"=="" GOTO SERVER_STANDALONE ELSE GOTO PRINT_USAGE


:SERVER_ND
CALL "%WAS_HOME%\bin\ws_ant" -f "%WAS_HOME%\BPM\Lombardi\tools\process-installer\util\processAppPackageManager.ant" -DWAS_HOME="%WAS_HOME%" -DprofileName=%PROFILENAME% -DnodeName=%NODENAME% -DserverName=%SERVERNAME% -Dhost=%HOST% -Dport=%PORT% -Dusername=%USERNAME% -Dpassword=%PASSWORD% -Dfile=%FILE% -Dstate=%2 installPackage
SET RC=%ERRORLEVEL%
GOTO END


:SERVER_STANDALONE
CALL "%WAS_HOME%\bin\ws_ant" -f "%WAS_HOME%\BPM\Lombardi\tools\process-installer\util\processAppPackageManager.ant" -DWAS_HOME="%WAS_HOME%" -DprofileName=%PROFILENAME% -Dhost=%HOST% -Dport=%PORT% -Dusername=%USERNAME% -Dpassword=%PASSWORD% -Dfile=%FILE% -Dstate=%2 installPackage
SET RC=%ERRORLEVEL%
GOTO END


:PRINT_USAGE
ECHO.
ECHO Usage: _internalInstallPackage [options...] ^<package name^> [PackageInstalled , InstallationServiceExecuted , GlobalAssetMigrated , InstancedMigrated, TrackingDefinitionsSent]
ECHO.
ECHO Options:
ECHO   -?, -help                             print this message
ECHO   -h ^<host^>, -host ^<host^>               host of the process server where to deploy the package
ECHO   -t ^<port^>, -port ^<port^>               port of the process server where to deploy the package
ECHO   -u ^<username^>, -username ^<username^>   username of the process server administrator
ECHO   -p ^<password^>, -password ^<password^>   user password (unencrypted)
ECHO   -profileName ^<name^>                   profile name
ECHO   -nodeName ^<name^>                      node name in an ND Environment
ECHO   -serverName ^<name^>                    server name in an ND Environment
ECHO.
GOTO END


:END
EXIT /B %RC%
ENDLOCAL
