@ECHO off
REM
REM THIS PRODUCT CONTAINS RESTRICTED MATERIALS OF IBM
REM
REM  5724-I63, 5724-H88, 5655-N02, 5733-W70 (C) COPYRIGHT International Business Machines Corp. 2005, 2012
REM
REM  The source code for this program is not published or otherwise divested
REM  of its trade secrets, irrespective of what has been deposited with the
REM  U.S. Copyright Office.
REM
REM ----------------------------------------------------------------------------

SETLOCAL

PUSHD %~dp0..\..\..\..\bin
CALL "setupCmdLine.bat" %*
POPD

SET RC=0
SET FILE=
SET BRANCH=
SET HOST=\"\"
SET PORT=\"\"
SET NODENAME=
SET SERVERNAME=

IF [%1]==[] SET RC=1 & GOTO PRINT_USAGE


:PARAM_LOOP
IF [%1]==[] GOTO VERIFY_INPUTS

IF [%1]==[-help] GOTO PRINT_USAGE
IF [%1]==[-?] GOTO PRINT_USAGE

IF [%1]==[-branch] SET BRANCH=%2 & SHIFT & SHIFT & GOTO PARAM_LOOP

IF [%1]==[-host] SET HOST=%2 & SHIFT & SHIFT & GOTO PARAM_LOOP
IF [%1]==[-h] SET HOST=%2 & SHIFT & SHIFT & GOTO PARAM_LOOP

IF [%1]==[-port] SET PORT=%2 & SHIFT & SHIFT & GOTO PARAM_LOOP
IF [%1]==[-t] SET PORT=%2 & SHIFT & SHIFT & GOTO PARAM_LOOP

IF [%1]==[-profileName] SET PROFILENAME=%2 & SHIFT & SHIFT & GOTO PARAM_LOOP

IF [%1]==[-serverName] SET SERVERNAME=%2 & SHIFT & SHIFT & GOTO PARAM_LOOP

IF [%1]==[-nodeName] SET NODENAME=%2 & SHIFT & SHIFT & GOTO PARAM_LOOP


:VERIFY_INPUTS
IF [%1]==[] SET RC=1 & ECHO Process app acronym is missing. & GOTO PRINT_USAGE
IF [%2]==[] SET RC=1 & ECHO Snapshot name is missing. & GOTO PRINT_USAGE
IF [%3]==[] SET RC=1 & ECHO Server name is missing. & GOTO PRINT_USAGE
IF [%4]==[] SET RC=1 & ECHO Package name is missing. & GOTO PRINT_USAGE
IF [%5]==[] SET RC=1 & ECHO Username is missing. & GOTO PRINT_USAGE
IF [%6]==[] SET RC=1 & ECHO Password is missing. & GOTO PRINT_USAGE

SET FILE=%~f4

IF "%NODENAME%"=="" GOTO CHECKSERVER_EMPTY
IF "%SERVERNAME%"=="" GOTO PRINT_USAGE
GOTO SERVER_ND
SET RC=1 & GOTO PRINT_USAGE

ECHO %1 %2 %3 %4 %5 %6
REM Check for both server and node names as empty as this is for a stand-alone profile
:CHECKSERVER_EMPTY
IF "%SERVERNAME%"=="" GOTO SERVER_STANDALONE ELSE GOTO PRINT_USAGE


:SERVER_ND
CALL "%WAS_HOME%\bin\ws_ant" -f "%WAS_HOME%\BPM\Lombardi\tools\process-installer\util\processAppPackageManager.ant" -DWAS_HOME="%WAS_HOME%" -DprofileName=%PROFILENAME% -DnodeName=%NODENAME% -DserverName=%SERVERNAME% -Dhost=%HOST% -Dport=%PORT% -Dusername="%5" -Dpassword="%6" -DprocessApp=%1 -Dsnapshot=%2 -Dserver=%3 -Dfile="%FILE%" retrievePackage
SET RC=%ERRORLEVEL%
GOTO END


:SERVER_STANDALONE
CALL "%WAS_HOME%\bin\ws_ant" -f "%WAS_HOME%\BPM\Lombardi\tools\process-installer\util\processAppPackageManager.ant" -DWAS_HOME="%WAS_HOME%" -DprofileName=%PROFILENAME% -Dhost=%HOST% -Dport=%PORT% -Dusername="%5" -Dpassword="%6" -DprocessApp=%1 -Dsnapshot=%2 -Dserver=%3 -Dfile="%FILE%" retrievePackage
SET RC=0
GOTO END


:PRINT_USAGE
ECHO.
ECHO Usage: retrieveProcessAppPackage [options...] ^<process app acronym^> ^<snapshot name^> ^<destination offline server name^> ^<destination installation package file^> ^<username of the process center server administrator^> ^<user password^>
ECHO.
ECHO Options:
ECHO   -?, -help			print this message
ECHO   -branch ^<branch name^>		name of the workspace of the installed snapshot
ECHO   -h ^<host^>, -host ^<host^>	host of the process center server where the snapshot is installed, required parameter in ND Environment
ECHO   -t ^<port^>, -port ^<port^>	port of the process center server where the snapshot is installed, required parameter in ND Environment
ECHO   -profileName ^<name^>		profile name
ECHO   -nodeName ^<name^>		node name, required parameter in ND Environment
ECHO   -serverName ^<name^>		server name, required parameter in ND Environment
ECHO.
GOTO END


:END
EXIT /B %RC%
ENDLOCAL
