@echo off

SET USERNAME_ARG=
SET PASSWORD_ARG=
SET HOSTNAME=
SET SERVERPORT=
SET PROCESS_APP_NAME=" "
SET MAX_HITS=" "
SET TASK_STATUS_VALUES=" "
SET INSTANCE_STATUS_VALUES=" "
SET TASK_USER=" "
SET AUTHORIZATION_TYPE=" "
SET TASK_ID_LIST=" "
SET SEARCH_STRING=

:processArguments
IF "%1" == "-?" GOTO help
IF "%1" == "-help" GOTO help

IF "%1"=="-username" SET USERNAME_ARG=%2 & SHIFT & SHIFT & GOTO processArguments
IF "%1"=="-u" SET USERNAME_ARG=%2 & SHIFT & SHIFT & GOTO processArguments
IF "%1"=="-user" SET USERNAME_ARG=%2 & SHIFT & SHIFT & GOTO processArguments

IF "%1"=="-password" SET PASSWORD_ARG=%2 & SHIFT & SHIFT & GOTO processArguments
IF "%1"=="-p" SET PASSWORD_ARG=%2 & SHIFT & SHIFT & GOTO processArguments

IF "%1"=="-host" SET HOSTNAME=%2 & SHIFT & SHIFT & GOTO processArguments

IF "%1"=="-port" SET SERVERPORT=%2 & SHIFT & SHIFT & GOTO processArguments

IF "%1"=="-processAppName" SET PROCESS_APP_NAME=%2 & SHIFT & SHIFT & GOTO processArguments

IF "%1"=="-maxhits" SET MAX_HITS=%2 & SHIFT & SHIFT & GOTO processArguments

IF "%1"=="-taskStatusValues" SET TASK_STATUS_VALUES=%2 & SHIFT & SHIFT & GOTO processArguments

IF "%1"=="-instanceStatusValues" SET INSTANCE_STATUS_VALUES=%2 & SHIFT & SHIFT & GOTO processArguments

IF "%1"=="-taskuser" SET TASK_USER=%2 & SHIFT & SHIFT & GOTO processArguments

IF "%1"=="-authorizationType" SET AUTHORIZATION_TYPE=%2 & SHIFT & SHIFT & GOTO processArguments

IF "%1"=="-taskIdList" SET TASK_ID_LIST=%2 & SHIFT & SHIFT & GOTO processArguments

IF NOT "%1"=="" SET TEMP_STRING=%1 & SET FIRST_CHAR=%TEMP_STRING:~0,1%

IF "%FIRST_CHAR%"=="-" GOTO help

IF NOT "%1"=="" SET SEARCH_STRING=%SEARCH_STRING% %1 & SHIFT & GOTO processArguments

IF "%SEARCH_STRING%"=="" GOTO help

@REM if username is specified, password is required
SET SECURITY_PARM=
IF "%USERNAME_ARG%"=="" GOTO usermsg
IF "%PASSWORD_ARG%"=="" GOTO usermsg
SET SECURITY_PARM=-user %USERNAME_ARG% -password %PASSWORD_ARG%
GOTO chkhost
:usermsg
ECHO.
ECHO -username and -password both must be specified
GOTO help

@REM if hostname is specified, port is required
:chkhost
IF "%HOSTNAME%"=="" GOTO nohost
IF "%SERVERPORT%"=="" GOTO hostmsg
GOTO hostparm
:nohost
IF "%SERVERPORT%"=="" GOTO hostparm
:hostmsg
ECHO.
ECHO -host and -port both must be specified
GOTO help
   
:hostparm
IF "%HOSTNAME%"=="" GOTO noservername

wsadmin -lang jython -wsadmin_classpath %WAS_HOME%"/BPM/Lombardi/lib/ps.jar";%WAS_HOME%"/BPM/Lombardi/lib/utility.jar" %SECURITY_PARM% -conntype SOAP -host %HOSTNAME% -port %SERVERPORT% -f %WAS_HOME%"/BPM/Lombardi/tools/search-index/taskIndexSearch.jy" "%SEARCH_STRING%" %PROCESS_APP_NAME% %MAX_HITS% %TASK_STATUS_VALUES% %INSTANCE_STATUS_VALUES% %TASK_USER% %AUTHORIZATION_TYPE% %TASK_ID_LIST%

GOTO END

:noservername

wsadmin -lang jython -wsadmin_classpath %WAS_HOME%"/BPM/Lombardi/lib/ps.jar";%WAS_HOME%"/BPM/Lombardi/lib/utility.jar" %SECURITY_PARM%  -f %WAS_HOME%"/BPM/Lombardi/tools/search-index/taskIndexSearch.jy" "%SEARCH_STRING%" %PROCESS_APP_NAME% %MAX_HITS% %TASK_STATUS_VALUES% %INSTANCE_STATUS_VALUES% %TASK_USER% %AUTHORIZATION_TYPE% %TASK_ID_LIST%

GOTO END

:help
ECHO Usage:
ECHO.
ECHO    taskIndexSearch.bat [options...] searchString
ECHO.
ECHO Options:
ECHO    -?, -help                    This help message
ECHO    -u,-username ^<username^>      user name of admin user
ECHO    -p,-password ^<password^>      password for the admin user (unencrypted), must be used with username
ECHO    -host                        server host name, must be used with port
ECHO    -port                        server SOAP port number
ECHO    -processAppName              Process Application Name
ECHO    -maxhits                     Maximum number of hits.  If more than
ECHO                                    the maximum are found 
ECHO                                    an exception is returned
ECHO    -taskStatusValues            Task status value.  Blank returns ALL
ECHO    -instanceStatusValues        Instance status value.  Blank returns ALL
ECHO    -taskuser                    user name associated with the task.  
ECHO                                    Blank returns all.
ECHO    -authorizationType           Authorization type: 
ECHO                                    owner
ECHO                                    potentialOwner
ECHO                                    ownerOrPotentialOwner
ECHO    -taskIdList                  List of Task IDs.Blank returns all.
ECHO.
ECHO searchString:
ECHO    Enter a search string for retrieving task information from the task index.

GOTO END

:END
ECHO.
EXIT /B %RC%
ENDLOCAL
