@ECHO OFF

SETLOCAL

ECHO.
ECHO IBM Business Process Manager 8.0 Search Optimization - Data Load
ECHO.

SET SCRIPT_DIR=%~dp0
PUSHD %SCRIPT_DIR%..\..\..\..\bin
CALL "setupCmdLine.bat" %*
POPD

IF NOT "%USER_INSTALL_ROOT%"=="" GOTO setupArguments
ECHO .
ECHO Profile does not exist.
ECHO.
SET RC=1
GOTO help

:setupArguments
SET LOGGING_PROP=-Dcom.lombardisoftware.ant.JULDefaultLogger.level=DEBUG -Djava.util.logging.config.file="%SCRIPT_DIR%/loggingLoad.properties" -Dtw.log4j.init=false
SET LOGGING_PROP=%LOGGING_PROP% -Dcom.lombardi.logging.StringFilter.excludes=contains(db.password);equals(WSVR0072W);equals(WSVR0801I);equals(WKSP0500)

SET PLUGINS_DIR=%WAS_HOME%/plugins
SET RUNTIMES_DIR=%WAS_HOME%/runtimes
SET BPM_LIB_DIR=%WAS_HOME%/BPM/Lombardi/lib
SET BPM_JDBCDRIVERS_DIR=%WAS_HOME%/jdbcdrivers

SET CLASSPATH=%SCRIPT_DIR%
SET CLASSPATH=%CLASSPATH%;lib/search-opt.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ws.admin.core.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ws.admin.services.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ws.admin.system.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ws.bpm.repository.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ws.bpm.utils.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ws.bpm.wccm.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ws.emf.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.ws.runtime.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.wsspi.extension.jar
SET CLASSPATH=%CLASSPATH%;%PLUGINS_DIR%/com.ibm.wsspi.proxy.extension.jar
SET CLASSPATH=%CLASSPATH%;%RUNTIMES_DIR%/com.ibm.ws.admin.client_8.5.0.jar
SET CLASSPATH=%CLASSPATH%;%BPM_LIB_DIR%/langutil.jar
SET CLASSPATH=%CLASSPATH%;%BPM_LIB_DIR%/log4j.jar
SET CLASSPATH=%CLASSPATH%;%BPM_LIB_DIR%/psapiclnt.jar
SET CLASSPATH=%CLASSPATH%;%BPM_LIB_DIR%/psclnt.jar
SET CLASSPATH=%CLASSPATH%;%BPM_LIB_DIR%/pssearch.jar
SET CLASSPATH=%CLASSPATH%;%BPM_LIB_DIR%/svrcoreclnt.jar
SET CLASSPATH=%CLASSPATH%;%BPM_LIB_DIR%/jdom.jar
SET CLASSPATH=%CLASSPATH%;%BPM_LIB_DIR%/oro.jar
SET CLASSPATH=%CLASSPATH%;%BPM_JDBCDRIVERS_DIR%/DB2/db2jcc_license_cisuz.jar

:processArguments
IF "%1" == "-?" GOTO help
IF "%1" == "-help" GOTO help

IF "%1"=="-profileName" SHIFT&SHIFT&GOTO processArguments


"%JAVA_HOME%\bin\java" -cp "%CLASSPATH%" %LOGGING_PROP% -Dwas.install.root="%WAS_HOME%" -Dcom.ibm.ws.management.standalone=true -Dwas.repository.root="%USER_INSTALL_ROOT%/config" -Duser.install.root="%USER_INSTALL_ROOT%" com.lombardisoftware.tools.optimization.search.DataLoad
SET RC=%ERRORLEVEL%
GOTO end

:help
ECHO.
ECHO Loads data into pivot tables.
ECHO.
ECHO Usage:
ECHO.
ECHO    DataLoad.bat [options...]
ECHO.
ECHO Options:
ECHO    -?, -help                             This help message
ECHO    -profileName ^<name^>                 Profile name
ECHO .
GOTO end

:end
ECHO.
EXIT /B %RC%
ENDLOCAL